#include "bpe.h"


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
EWRAM_CODE void BpeInit(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
IWRAM_CODE void BpeDecode(u8* pSrc, u32 srcSize, u8* pDst)
{
	// G[`FbNȂĂ܂BNbV̋ꂠ

	u8  stackBuf[256];
	u8  stackHead = 0;

	u8  pair1[256];
	u8  pair2[256];

	u8  c1, c2, c3, c4;

	s32 size;
	s32 rpos;
	s32 i;

	u8* pSrcEnd = pSrc + srcSize;

	for(;;)
	{
		if(pSrc >= pSrcEnd)
		{
			break;
		}

		c1 = *pSrc++;
		c2 = *pSrc++;
		c3 = *pSrc++;

		size = c2 | (c3 << 8);
		rpos = 0;

		// kȂ
		if(c1 == 0x00)
		{
			while(rpos < size)
			{
				*pDst++ = *pSrc++;
				rpos++;
			}

			continue;
		}


		// k
		for(i=0; i<256; i++)
		{
			pair1[i] = i;
			pair2[i] = 0x00;
		}

		c1 = *pSrc++;

		for(i=0; i<c1; i++)
		{
			c2 = *pSrc++;
			c3 = *pSrc++;
			c4 = *pSrc++;

			pair1[c2] = c3;
			pair2[c2] = c4;
		}

		while(rpos < size || stackHead > 0)
		{
			if(stackHead == 0)
			{
				c1 = *pSrc++;
				rpos++;
			}
			else
			{
				c1 = stackBuf[--stackHead];
			}

			for(;;)
			{
				if(pair1[c1] == c1)
				{
					*pDst++ = c1;
					break;
				}

				stackBuf[stackHead++] = pair2[c1];
				c1 = pair1[c1];
			}
		}

	} // for(;;)
}
