# coding: Shift_JIS

import os
import Image
import struct


# ---------------------------------------------------------------------------
pdtcnt = 0


# ---------------------------------------------------------------------------
def PdtCrop(pS, sx, sy, cx, cy):
	global pdtcnt
	
	box  = (sx, sy, sx+cx, sy+cy)
	file = "Z" + "%03d" % (pdtcnt) + ".bmp"
	pD   = pS.crop(box)
	
	print "crop... " + str(pdtcnt)
	pD.save(file);
	pdtcnt += 1;

# ---------------------------------------------------------------------------
def PdtCropMask(pS1, pS2, sx, sy, cx, cy):
	global pdtcnt
	
	box   = (sx, sy, sx+cx, sy+cy)
	file1 = "Z" + "%03d"   % (pdtcnt) + ".bmp"
	file2 = "Z" + "%03d_M" % (pdtcnt) + ".bmp"
	pD1   = pS1.crop(box)
	pD2   = pS2.crop(box)
	
	print "cropmask... " + str(pdtcnt)
	pD1.save(file1);
	pD2.save(file2);
	pdtcnt += 1;

# ---------------------------------------------------------------------------
def PdtResize(file):
	p      = Image.open(file)
	iw, ih = p.size
	
	iw  = int(iw * 0.375)
	ih  = int(ih * 0.334)
	if(iw % 2 != 0): iw -= 1
	if(ih % 2 != 0): ih -= 1

	print "resize ... " + file
	cmd = "..\\..\\exe\\pdt\\convert.exe -resize %dx%d! " % (iw, ih)
	
	os.system(cmd + file + " " + file)
	#print cmd + file

# ---------------------------------------------------------------------------
pS = Image.open("AYU_02.bmp")
PdtCrop(pS, 162, 230, 76, 18)

pS = Image.open("MAI_02.bmp")
PdtCrop(pS, 410, 232, 60, 18)

pS = Image.open("MAK_02.bmp")
PdtCrop(pS, 162, 232, 76, 18)

pS = Image.open("NAY_02.bmp")
PdtCrop(pS, 162, 232, 76, 18)

pS = Image.open("SIO_02.bmp")
PdtCrop(pS, 410, 232, 60, 18)


pS = Image.open("WAKI_01.bmp")
PdtCrop(pS, 104, 226, 70, 18)

pS = Image.open("WAKI_02.bmp")
PdtCrop(pS, 440, 226, 90, 18)

pS = Image.open("WAKI_03.bmp")
PdtCrop(pS, 102, 226, 72, 18)

pS = Image.open("WAKI_04.bmp")
PdtCrop(pS, 448, 226, 74, 18)

# ---------------------------------------------------------------------------

pS = Image.open("AYU_05.bmp")
for i in xrange(8):
	PdtCrop(pS, 17, 11 + i*40, 240, 20)

pS = Image.open("KAN_MOJ2.bmp")
for i in xrange(8):
	PdtCrop(pS, 15, 11 + i*40, 114, 20)

pS = Image.open("MAI_05.bmp")
for i in xrange(8):
	PdtCrop(pS, 10, 11 + i*40, 210, 20)

pS = Image.open("MAK_05.bmp")
for i in xrange(8):
	PdtCrop(pS,  14, 11 + i*40,  90, 20)
	PdtCrop(pS, 104, 11 + i*40, 202, 20)

pS = Image.open("SIO_05.bmp")
for i in xrange(8):
	PdtCrop(pS,   9, 11 + i*40, 114, 20)
	PdtCrop(pS, 129, 11 + i*40, 170, 20)

# ---------------------------------------------------------------------------
pS = Image.open("KAN_MOJ.bmp")
for i in xrange(8):
	PdtCrop(pS, 10, 11 + i*40, 60, 20)

for i in xrange(8):
	PdtCrop(pS, 85, 11 + i*40, 90, 20)

for i in xrange(8):
	PdtCrop(pS, 184 + ((8 * (i/4)) + (112 * (i/4))), (i % 4)*96 + (i % 4)*4, 112, 96)

# ---------------------------------------------------------------------------
pS = Image.open("KAN_MOJ3.bmp")

PdtCrop(pS, 260,  20, 116, 16)
PdtCrop(pS, 152,  44, 164, 16)
PdtCrop(pS, 316,  44, 168, 16)
PdtCrop(pS, 212,  68, 216, 16)

PdtCrop(pS, 232,  92, 176, 16)
PdtCrop(pS, 216, 116, 204, 16)

# ---------------------------------------------------------------------------
for i in xrange(4, 20, 1):
	pS = Image.open("ROLL_" + "%03d" % (i) + ".bmp")
	iw, ih = pS.size
	
	if(iw % 2 != 0):
		pT = Image.new('RGB', (iw+1, ih), (255, 255, 255))
		pT.paste(pS, (0, 0))
		PdtCrop(pT, 0, 0, iw+1, ih)
	else:
		PdtCrop(pS, 0, 0, iw, ih)


#OP Song
pS = Image.open("ROLL_020.bmp")
PdtCrop(pS,   0, 0, 142, 16)
PdtCrop(pS, 149, 0, 122, 16)

pS = Image.open("ROLL_021.bmp")
iw, ih = pS.size
PdtCrop(pS, 0, 0, iw, ih)

# ED Song
pS = Image.open("ROLL_022.bmp")
PdtCrop(pS,   0, 0, 142, 16)
PdtCrop(pS, 150, 0, 142, 16)


for i in xrange(23, 34, 1):
	pS = Image.open("ROLL_" + "%03d" % (i) + ".bmp")
	iw, ih = pS.size
	
	if(iw % 2 != 0):
		pT = Image.new('RGB', (iw+1, ih), (255, 255, 255))
		pT.paste(pS, (0, 0))
		PdtCrop(pT, 0, 0, iw+1, ih)
	else:
		PdtCrop(pS, 0, 0, iw, ih)

# ---------------------------------------------------------------------------
pS1 = Image.open("S_AYU1.bmp")
pS2 = Image.open("S_AYU1_M.bmp")

PdtCropMask(pS1, pS2,  52, 100, 240, 28)
PdtCropMask(pS1, pS2, 400, 132, 128, 28)

PdtCropMask(pS1, pS2, 116, 164, 116, 28)
PdtCropMask(pS1, pS2, 404, 196, 124, 28)
PdtCropMask(pS1, pS2,  92, 228, 164, 28)
PdtCropMask(pS1, pS2, 380, 260, 168, 28)

PdtCropMask(pS1, pS2, 128, 292,  88, 28)
PdtCropMask(pS1, pS2, 244, 324, 152, 28)

# ---------------------------------------------------------------------------
pS1 = Image.open("S_AYU2.bmp")
pS2 = Image.open("S_AYU2_M.bmp")

PdtCropMask(pS1, pS2,  24,   2,  36, 24)
PdtCropMask(pS1, pS2,  24,  26, 108, 24)
PdtCropMask(pS1, pS2,  24,  50, 176, 24)
PdtCropMask(pS1, pS2,  24,  74, 168, 24)
PdtCropMask(pS1, pS2,  24,  98, 200, 24)
PdtCropMask(pS1, pS2,  24, 122,  56, 24)
PdtCropMask(pS1, pS2,  80, 122, 192, 24)
PdtCropMask(pS1, pS2,  24, 146,  56, 24)
PdtCropMask(pS1, pS2,  24, 170,  56, 24)
PdtCropMask(pS1, pS2,  24, 194,  72, 24)
PdtCropMask(pS1, pS2,  24, 218,  72, 24)
PdtCropMask(pS1, pS2,  24, 242,  72, 24)
PdtCropMask(pS1, pS2,  24, 266,  72, 24)
PdtCropMask(pS1, pS2,  24, 290,  72, 24)

PdtCropMask(pS1, pS2,  24, 314, 180, 24)
PdtCropMask(pS1, pS2,  24, 338, 100, 24)
PdtCropMask(pS1, pS2, 124, 338, 180, 24)
PdtCropMask(pS1, pS2,  24, 362, 204, 24)
PdtCropMask(pS1, pS2,  24, 386, 112, 24)
PdtCropMask(pS1, pS2, 136, 386, 156, 24)
PdtCropMask(pS1, pS2,  24, 410, 216, 24)

# ---------------------------------------------------------------------------
pS1 = Image.open("S_MAI1.bmp")
pS2 = Image.open("S_MAI1_M.bmp")

PdtCropMask(pS1, pS2, 208,   4, 220, 24)
PdtCropMask(pS1, pS2, 208,  36, 220, 24)
PdtCropMask(pS1, pS2, 208,  68, 220, 24)
PdtCropMask(pS1, pS2, 160, 100, 120, 24)
PdtCropMask(pS1, pS2, 280, 100, 196, 24)
PdtCropMask(pS1, pS2, 200, 132, 240, 24)
PdtCropMask(pS1, pS2, 144, 164, 100, 24)
PdtCropMask(pS1, pS2, 248, 164, 240, 24)
PdtCropMask(pS1, pS2, 272, 196,  96, 24)
PdtCropMask(pS1, pS2, 272, 228,  96, 24)

# ---------------------------------------------------------------------------
pS1 = Image.open("S_MAK1.bmp")
pS2 = Image.open("S_MAK1_M.bmp")

PdtCropMask(pS1, pS2, 212,   4, 216, 24)
PdtCropMask(pS1, pS2, 136,  36, 176, 24)
PdtCropMask(pS1, pS2, 312,  36, 192, 24)
PdtCropMask(pS1, pS2, 244,  68, 152, 24)
PdtCropMask(pS1, pS2, 184, 100,  64, 24)

PdtCropMask(pS1, pS2, 248, 100, 208, 24)
PdtCropMask(pS1, pS2, 164, 132, 104, 24)
PdtCropMask(pS1, pS2, 268, 132, 208, 24)
PdtCropMask(pS1, pS2, 264, 164, 112, 24)
PdtCropMask(pS1, pS2, 296, 196,  48, 24)
PdtCropMask(pS1, pS2, 268, 228, 104, 24)
PdtCropMask(pS1, pS2, 296, 260,  48, 24)
PdtCropMask(pS1, pS2, 264, 292, 112, 24)
PdtCropMask(pS1, pS2, 292, 324,  52, 24)

# ---------------------------------------------------------------------------
pS = Image.open("S_MAK2.bmp")

PdtCrop(pS, 244,  80, 232, 44)
PdtCrop(pS, 128, 108,  60, 24)
PdtCrop(pS,  36, 176, 164, 24)
PdtCrop(pS, 364, 192, 244, 24)
PdtCrop(pS, 480, 268, 120, 24)
PdtCrop(pS, 388, 336, 116, 24)
PdtCrop(pS, 132, 364,  60, 24)

# ---------------------------------------------------------------------------
pS1 = Image.open("S_NAY1.bmp")
pS2 = Image.open("S_NAY1_M.bmp")

PdtCropMask(pS1, pS2,   4,   4,  76, 24)
PdtCropMask(pS1, pS2,   4,  36,  68, 24)
PdtCropMask(pS1, pS2,  72,  36, 184, 24)
PdtCropMask(pS1, pS2,   4,  68,  48, 24)
PdtCropMask(pS1, pS2,  52,  68, 236, 24)
PdtCropMask(pS1, pS2,   4, 100,  88, 24)
PdtCropMask(pS1, pS2,   4, 132, 168, 24)
PdtCropMask(pS1, pS2, 172, 132, 148, 24)
PdtCropMask(pS1, pS2,   4, 164, 120, 24)
PdtCropMask(pS1, pS2, 124, 164, 136, 24)
PdtCropMask(pS1, pS2,   4, 196, 196, 24)
PdtCropMask(pS1, pS2,   4, 228, 176, 24)
PdtCropMask(pS1, pS2,   4, 260, 116, 24)
PdtCropMask(pS1, pS2,   4, 292,  76, 24)
PdtCropMask(pS1, pS2,  80, 292, 220, 24)
PdtCropMask(pS1, pS2,   4, 324, 102, 24)
PdtCropMask(pS1, pS2, 106, 324, 152, 24)
PdtCropMask(pS1, pS2,   4, 356, 180, 24)
PdtCropMask(pS1, pS2,   4, 388, 176, 24)
PdtCropMask(pS1, pS2,   4, 420,  72, 24)
PdtCropMask(pS1, pS2,   4, 452, 110, 24)
PdtCropMask(pS1, pS2, 114, 452, 184, 24)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP01.bmp")

PdtCrop(pS, 304,   0,  32, 18)
PdtCrop(pS, 272,  18,  98, 16)
PdtCrop(pS, 278,  36,  86, 16)
PdtCrop(pS, 264,  52, 114, 16)
PdtCrop(pS, 294,  70,  54, 16)
PdtCrop(pS, 270,  86, 102, 16)
PdtCrop(pS, 260, 104, 122, 16)
PdtCrop(pS, 270, 120, 102, 16)
PdtCrop(pS, 270, 138, 102, 16)
PdtCrop(pS, 158, 154, 152, 16)
PdtCrop(pS, 312, 154, 174, 16)
PdtCrop(pS, 244, 171, 160, 16)
PdtCrop(pS, 104, 188, 228, 16)
PdtCrop(pS, 332, 188, 206, 16)
PdtCrop(pS, 260, 206, 124, 16)
PdtCrop(pS, 234, 222, 176, 16)
PdtCrop(pS, 230, 240, 182, 16)
PdtCrop(pS, 204, 256, 234, 16)
PdtCrop(pS, 220, 274, 202, 16)
PdtCrop(pS, 282, 290,  78, 16)
PdtCrop(pS, 282, 308,  78, 16)
PdtCrop(pS, 264, 324, 114, 16)
PdtCrop(pS, 244, 342, 154, 16)
PdtCrop(pS, 258, 358, 128, 16)
PdtCrop(pS, 278, 376,  86, 16)
PdtCrop(pS, 270, 392, 106, 16)
PdtCrop(pS, 208, 410, 226, 16)
PdtCrop(pS, 214, 426, 214, 16)
PdtCrop(pS, 256, 443, 134, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP02.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 270,  18, 102, 16)
PdtCrop(pS, 276,  36,  90, 16)
PdtCrop(pS, 268,  52, 106, 16)
PdtCrop(pS, 252,  70, 138, 16)
PdtCrop(pS, 214,  86, 220, 16)
PdtCrop(pS, 218, 104, 206, 16)
PdtCrop(pS, 120, 120, 192, 16)
PdtCrop(pS, 314, 120, 210, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP03.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 136,  18, 236, 18)
PdtCrop(pS, 372,  16, 136, 18)
PdtCrop(pS, 258,  34, 128, 18)
PdtCrop(pS, 226,  52, 192, 18)
PdtCrop(pS, 204,  69, 234, 16)
PdtCrop(pS, 166,  86, 134, 16)
PdtCrop(pS, 300,  86, 176, 16)
PdtCrop(pS, 202, 103, 238, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP04.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 250,  18, 142, 16)
PdtCrop(pS, 244,  35, 154, 16)
PdtCrop(pS, 250,  52, 142, 16)
PdtCrop(pS, 258,  70, 132, 16)
PdtCrop(pS, 184,  86, 174, 16)
PdtCrop(pS, 358,  86, 100, 16)
PdtCrop(pS, 268, 103, 106, 16)
PdtCrop(pS, 248, 120, 146, 16)
PdtCrop(pS, 272, 138, 100, 16)
PdtCrop(pS, 140, 154, 194, 16)
PdtCrop(pS, 338, 154, 164, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP05.bmp")

PdtCrop(pS, 306,   0,  28, 18)
PdtCrop(pS, 250,  18, 142, 16)
PdtCrop(pS, 232,  36, 182, 16)
PdtCrop(pS, 248,  52, 152, 16)
PdtCrop(pS, 272,  70, 104, 16)
PdtCrop(pS, 240,  86, 162, 16)
PdtCrop(pS, 288, 104,  70, 16)
PdtCrop(pS, 298, 120,  52, 16)
PdtCrop(pS, 260, 138, 122, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP06.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 264,  18, 114, 16)
PdtCrop(pS, 218,  35, 208, 16)
PdtCrop(pS, 232,  52, 180, 16)
PdtCrop(pS, 220,  69, 202, 16)
PdtCrop(pS, 288,  86,  66, 16)
PdtCrop(pS, 226, 103, 190, 16)
PdtCrop(pS, 204, 120, 234, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP07.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 230,  18, 182, 16)
PdtCrop(pS, 260,  36, 122, 16)
PdtCrop(pS, 256,  52, 124, 16)
PdtCrop(pS, 260,  69, 106, 16)
PdtCrop(pS, 214,  86, 214, 16)
PdtCrop(pS, 260, 104, 122, 16)
PdtCrop(pS, 288, 120,  66, 16)
PdtCrop(pS, 238, 137, 166, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP08.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 272,  18, 100, 16)
PdtCrop(pS, 264,  35, 114, 16)
PdtCrop(pS, 258,  52, 126, 16)
PdtCrop(pS, 214,  70, 214, 16)
PdtCrop(pS, 232,  86, 178, 16)
PdtCrop(pS, 186, 103,  98, 16)
PdtCrop(pS, 286, 103, 170, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP98.bmp")

PdtCrop(pS, 264,  0, 114, 18)
PdtCrop(pS, 154, 18, 102, 16)
PdtCrop(pS, 258, 18, 230, 16)
PdtCrop(pS, 216, 36, 216, 16)
PdtCrop(pS, 238, 52, 172, 16)
PdtCrop(pS, 220, 70, 202, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_OP99.bmp")

PdtCrop(pS, 308,   0,  26, 18)
PdtCrop(pS, 270,  18, 102, 16)
PdtCrop(pS, 150,  36, 180, 16)
PdtCrop(pS, 330,  36, 162, 16)
PdtCrop(pS, 168,  52, 168, 16)
PdtCrop(pS, 336,  52, 138, 16)
PdtCrop(pS, 144,  69, 200, 16)
PdtCrop(pS, 344,  69, 154, 16)
PdtCrop(pS, 302,  86,  40, 16)
PdtCrop(pS, 212, 103, 218, 16)
PdtCrop(pS, 286, 120,  70, 16)
PdtCrop(pS, 220, 138, 202, 16)
PdtCrop(pS, 244, 154, 156, 16)
PdtCrop(pS, 264, 171, 118, 16)

# ---------------------------------------------------------------------------
pS1 = Image.open("S_SIO1.bmp")
pS2 = Image.open("S_SIO1_M.bmp")

PdtCropMask(pS1, pS2, 272,   8,  98, 16)
PdtCropMask(pS1, pS2, 234,  40, 172, 16)
PdtCropMask(pS1, pS2, 180,  72,  98, 16)
PdtCropMask(pS1, pS2, 278,  72, 182, 16)
PdtCropMask(pS1, pS2, 212, 104, 216, 16)
PdtCropMask(pS1, pS2, 222, 136, 196, 16)
PdtCropMask(pS1, pS2, 250, 168, 140, 16)
PdtCropMask(pS1, pS2, 208, 200, 224, 16)
PdtCropMask(pS1, pS2, 162, 232, 216, 16)
PdtCropMask(pS1, pS2, 380, 232,  96, 16)
PdtCropMask(pS1, pS2, 160, 264, 148, 16)
PdtCropMask(pS1, pS2, 310, 264, 170, 16)
PdtCropMask(pS1, pS2, 250, 296, 142, 16)

# ---------------------------------------------------------------------------
pS = Image.open("S_SIO2.bmp")

PdtCrop(pS, 206, 14, 230, 20)
PdtCrop(pS, 122, 64, 130, 20)
PdtCrop(pS, 256, 64, 136, 20)
PdtCrop(pS, 398, 64, 122, 20)


# ---------------------------------------------------------------------------
pS = Image.open("MSG_01.bmp")
cnt = pdtcnt

PdtCrop(pS, 0,  50, 640, 200)
PdtCrop(pS, 0, 250, 640, 200)

for i in xrange(cnt, pdtcnt, 1):
	file = "Z" + "%03d" % (i) + ".bmp"
	PdtResize(file)

# ---------------------------------------------------------------------------
pS1 = Image.open("DAYS.bmp")
pS2 = Image.open("DAYS_M.bmp")
cnt = pdtcnt

for i in xrange(31):
	PdtCropMask(pS1, pS2, (i % 8) * 75, (i / 8) * 49, 75, 49)

for i in xrange(7):
	PdtCropMask(pS1, pS2, 150 + (i % 4) * 66, 196 + (i / 4) * 20, 66, 20)

PdtCropMask(pS1, pS2, 0, 196, 150, 116)


for i in xrange(cnt, pdtcnt, 1):
	file = "Z" + "%03d" % (i) + ".bmp"
	PdtResize(file)

for i in xrange(cnt, pdtcnt, 1):
	file = "Z" + "%03d" % (i) + "_M.bmp"
	PdtResize(file)


