# coding: Shift_JIS

import os
import re
import Image
import struct

# ---------------------------------------------------------------------------
def Img2bin(file):
	print 'img2bin ... ' + file
	
	p = Image.open(file)
	iw, ih = p.size
	
	os.system('..\\..\\exe\\pdt\\grit.exe ' + file + ' -gb -gB16 -ftb -gu16 -gzl -fh!')
	
	f = open(file[:-4] + ".img.bin", "rb")
	x = f.read()
	f.close()
	
	f = open(file[:-4] + ".img.bin", 'wb')
	f.write(struct.pack('HH', iw, ih))
	f.write(x);
	f.close()

# ---------------------------------------------------------------------------
def Img2mask(file):
	print 'img2mask ... ' + file
	
	p = Image.open(file)
	iw, ih = p.size
	
	os.system('..\\..\\exe\\pdt\\grit.exe ' + file + ' -gb -gB16 -ftb -gu16 -gz! -fh!')
	
	f = open(file[:-4] + ".img.bin", "rb")
	x = f.read()
	f.close()
	
	f = open(file[:-4] + ".img.bin", 'wb')
	for i in range(len(x)):
		if((i % 2) == 0):
			f.write(struct.pack('B', ord(x[i]) & 0x1f))
	f.close()
	
	os.system('..\\..\\exe\\pdt\\gbalzss.exe e ' + file[:-4] + ".img.bin" + ' ' + file[:-4] + ".img")
	
	f = open(file[:-4] + ".img", "rb")
	x = f.read()
	f.close()
	
	f = open(file[:-4] + ".img", 'wb')
	f.write(struct.pack('HH', iw, ih))
	f.write(x);
	f.close()

# ---------------------------------------------------------------------------
def Resize(file):
	print 'resize ... ' + file
	cmd  = ''
	
	p = Image.open(file)
	iw, ih = p.size
	
	if (iw >= 640) and (ih >= 480):
		cmd = "..\\..\\exe\\pdt\\convert.exe -resize 240x160! ";
	else:
		iw  = int(iw * 0.375)
		ih  = int(ih * 0.334)
		if(iw % 2 != 0): iw -= 1
		if(ih % 2 != 0): ih -= 1
		cmd = "..\\..\\exe\\pdt\\convert.exe -resize %dx%d! " % (iw, ih)
	
	os.system(cmd + file + " " + file)
#	print cmd + file

# ---------------------------------------------------------------------------
def GetLR(p, iw, ih, col):
	for x in range(iw):
		for y in range(ih):
			c = p.getpixel((x, y))
			if(c[0] != col or c[1] != col or c[2] != col):
				return x
	
	assert 0

# ---------------------------------------------------------------------------
def GetRL(p, iw, ih, col):
	for x in range(iw):
		for y in range(ih):
			c = p.getpixel(((iw-1) - x, (ih-1) - y))
			if(c[0] != col or c[1] != col or c[2] != col):
				return (iw-1) - x
	
	assert 0

# ---------------------------------------------------------------------------
def GetUD(p, iw, ih, col):
	for y in range(ih):
		for x in range(iw):
			c = p.getpixel((x, y))
			if(c[0] != col or c[1] != col or c[2] != col):
				return y
	
	assert 0

# ---------------------------------------------------------------------------
path = os.getcwd()
dir  = os.listdir(path)
p1   = re.compile('Z.*\.bmp')
p2   = re.compile('Z.*\_M.bmp')

z  = [i for i in dir if p1.match(i)]
zm = [i for i in dir if p2.match(i)]
al = [i for i in dir if i.find('.bmp') != -1]
am = [i for i in dir if i.find('_M.bmp') != -1]
a  = [i for i in al  if i not in am]
b  = [i for i in a   if i not in z]
bm = [i for i in am  if i not in zm]


for i in range(len(b)):
	Resize(b[i])

for i in range(len(bm)):
	Resize(bm[i])


# ---------------------------------------------------------------------------
# mask patch
p = Image.open("CGKG10N_M.bmp")
p2 = p.crop((1, 0, 2, 160))
p.paste(p2, (0, 0))
p.paste(p2, (239, 0))

p.save("CGKG10N_M.bmp")

# ---------------------------------------------------------------------------
list = [
	["CGAK10", 0],
	["CGAK10A", 0],
	["CGAK11", 0],
	["CGAK11A", 0],
	["CGAK12", 0],
	["CGAK12A", 0],
	["CGAK13", 0],
	["CGAK13A", 0],
	["CGAK14", 0],
	["CGAK14A", 0],
	["CGAK15", 0],
	["CGAK15A", 0],
	["CGAM10", 0],
	["CGAM11", 0],
	["CGAM12", 0],
	["CGAM13", 0],
	["CGAM14", 0],
	["CGAM15", 0],
	["CGAY10", 0],
	["CGAY10A", 0],
	["CGAY10B", 0],
	["CGAY10BN", 0],
	["CGAY10N", 0],
	["CGAY11", 0],
	["CGAY11A", 0],
	["CGAY11B", 0],
	["CGAY12", 0],
	["CGAY13", 0],
	["CGAY13A", 0],
	["CGAY13B", 0],
	["CGAY14", 0],
	["CGAY14A", 0],
	["CGAY14B", 0],
	["CGAY14BN", 0],
	["CGAY15", 0],
	["CGAY15A", 0],
	["CGAY15B", 0],
	["CGAY15BN", 0],
	["CGAY16", 0],
	["CGAY16A", 0],
	["CGAY16B", 0],
	["CGAY16BN", 0],
	["CGAY17", 0],
	["CGAY17A", 0],
	["CGAY17B", 0],
	["CGAY17BN", 0],
	["CGAY20", 0],
	["CGAY20A", 0],
	["CGAY20B", 0],
	["CGAY20BN", 0],
	["CGAY20N", 0],
	["CGAY21", 0],
	["CGAY21A", 0],
	["CGAY21B", 0],
	["CGAY21BN", 0],
	["CGAY21N", 0],
	["CGAY22", 0],
	["CGAY22A", 0],
	["CGAY22AN", 0],
	["CGAY22B", 0],
	["CGAY22BN", 0],
	["CGAY23", 0],
	["CGAY23A", 0],
	["CGAY23B", 0],
	["CGAY23N", 0],
	["CGAY24", 0],
	["CGAY24A", 0],
	["CGAY24B", 0],
	["CGAY24BN", 0],
	["CGAY24N", 0],
	["CGAY25", 0],
	["CGAY25A", 0],
	["CGAY25B", 0],
	["CGAY25BN", 0],
	["CGAY25N", 0],
	["CGAY26", 0],
	["CGAY27", 0],
	["CGAY27A", 0],
	["CGAY27B", 0],
	["CGAY27BN", 0],
	["CGAY28", 0],
	["CGAY28A", 0],
	["CGAY28B", 0],
	["CGAY28BN", 0],
	["CGAY28N", 0],
	["CGAY30", 0],
	["CGAY30A", 0],
	["CGAY30N", 0],
	["CGAY31", 0],
	["CGAY31A", 0],
	["CGAY31B", 0],
	["CGAY31BN", 0],
	["CGAY31N", 0],
	["CGAY32", 0],
	["CGAY32A", 0],
	["CGAY32B", 0],
	["CGAY32BN", 0],
	["CGAY33", 0],
	["CGAY33A", 0],
	["CGAY34", 0],
	["CGAY34A", 0],
	["CGAY34B", 0],
	["CGAY34BN", 0],
	["CGAY34N", 0],
	["CGAY35", 0],
	["CGAY35A", 0],
	["CGAY35BN", 0],
	["CGAY35N", 0],
	["CGKAY10", 0],
	["CGKAY10N", 0],
	["CGKAY11", 0],
	["CGKAY11N", 0],
	["CGKAY12", 0],
	["CGKAY13", 0],
	["CGKAY20", 0],
	["CGKAY20N", 0],
	["CGKAY21", 0],
	["CGKAY21N", 0],
	["CGKAY22", 0],
	["CGKAY22N", 0],
	["CGKAY23", 0],
	["CGKAY23N", 0],
	["CGKAY24", 0],
	["CGKAY25", 0],
	["CGKAY25N", 0],
	["CGKAY26", 0],
	["CGKAY26N", 0],
	["CGKAY27", 0],
	["CGKG10", 0],
	["CGKG10N", 0],
	["CGKNY10", 0],
	["CGKNY11", 0],
	["CGKNY12", 0],
	["CGKNY13", 0],
	["CGKR10", 0],
	["CGKR10N", 0],
	["CGKR11", 0],
	["CGKR11N", 0],
	["CGKR12", 0],
	["CGKR12N", 0],
	["CGKR13", 0],
	["CGKR14", 0],
	["CGKR14N", 0],
	["CGKR20", 0],
	["CGKR20N", 0],
	["CGKR21", 0],
	["CGKR22", 0],
	["CGKR23", 0],
	["CGKR24", 0],
	["CGKR25", 0],
	["CGKR25N", 0],
	["CGMI10", 3],
	["CGMI10B", 3],
	["CGMI10N", 3],
	["CGMI11", 3],
	["CGMI12", 3],
	["CGMI13", 3],
	["CGMI14", 3],
	["CGMI14B", 3],
	["CGMI14N", 3],
	["CGMI15", 3],
	["CGMI15B", 3],
	["CGMI15N", 3],
	["CGMI16", 3],
	["CGMI20", 0],
	["CGMI20B", 0],
	["CGMI20N", 0],
	["CGMI21", 0],
	["CGMI21B", 0],
	["CGMI21N", 0],
	["CGMI22", 0],
	["CGMI22B", 0],
	["CGMI22N", 0],
	["CGMI23", 0],
	["CGMI23N", 0],
	["CGMI24N", 0],
	["CGMI25", 0],
	["CGMI26", 0],
	["CGMI26B", 0],
	["CGMI26N", 0],
	["CGMI30N", 0],
	["CGMI31", 0],
	["CGMK10", 0],
	["CGMK10B", 0],
	["CGMK10BC", 0],
	["CGMK10C", 0],
	["CGMK11", 0],
	["CGMK11B", 0],
	["CGMK11N", 0],
	["CGMK12", 0],
	["CGMK12B", 0],
	["CGMK12BC", 0],
	["CGMK12BN", 0],
	["CGMK12C", 0],
	["CGMK12N", 0],
	["CGMK13", 0],
	["CGMK13B", 0],
	["CGMK13C", 0],
	["CGMK14", 0],
	["CGMK14B", 0],
	["CGMK14BN", 0],
	["CGMK14C", 0],
	["CGMK15", 0],
	["CGMK15B", 0],
	["CGMK15C", 0],
	["CGMK16", 0],
	["CGMK16B", 0],
	["CGMK16BN", 0],
	["CGMK20", 0],
	["CGMK20B", 0],
	["CGMK20BC", 0],
	["CGMK20BN", 0],
	["CGMK20C", 0],
	["CGMK20N", 0],
	["CGMK21", 0],
	["CGMK21B", 0],
	["CGMK21BC", 0],
	["CGMK21BN", 0],
	["CGMK21C", 0],
	["CGMK21N", 0],
	["CGMK22", 0],
	["CGMK22B", 0],
	["CGMK22BC", 0],
	["CGMK22BN", 0],
	["CGMK22C", 0],
	["CGMK22N", 0],
	["CGMK23", 0],
	["CGMK23B", 0],
	["CGMK23BN", 0],
	["CGMK23C", 0],
	["CGMK24", 0],
	["CGMK24B", 0],
	["CGMK24C", 0],
	["CGMK24N", 0],
	["CGMK25", 0],
	["CGMK25B", 0],
	["CGMK30", 0],
	["CGMK31", 0],
	["CGNY10", 0],
	["CGNY10A", 0],
	["CGNY10B", 0],
	["CGNY10BN", 0],
	["CGNY10N", 0],
	["CGNY11", 0],
	["CGNY11A", 0],
	["CGNY11B", 0],
	["CGNY11BN", 0],
	["CGNY11N", 0],
	["CGNY12", 0],
	["CGNY12A", 0],
	["CGNY12B", 0],
	["CGNY12BN", 0],
	["CGNY13", 0],
	["CGNY13A", 0],
	["CGNY13B", 0],
	["CGNY13BN", 0],
	["CGNY14", 0],
	["CGNY14A", 0],
	["CGNY14B", 0],
	["CGNY14BN", 0],
	["CGNY15", 0],
	["CGNY15A", 0],
	["CGNY15B", 0],
	["CGNY15BN", 0],
	["CGNY16", 0],
	["CGNY16A", 0],
	["CGNY16B", 0],
	["CGNY16BN", 0],
	["CGNY17", 0],
	["CGNY17A", 0],
	["CGNY17B", 0],
	["CGNY17BN", 0],
	["CGNY17N", 0],
	["CGNY18", 0],
	["CGNY18A", 0],
	["CGNY18B", 0],
	["CGNY19", 0],
	["CGNY19A", 0],
	["CGNY19B", 0],
	["CGNY20", 0],
	["CGNY20A", 0],
	["CGNY20B", 0],
	["CGNY20BN", 0],
	["CGNY20N", 0],
	["CGNY21", 0],
	["CGNY21A", 0],
	["CGNY21B", 0],
	["CGNY22A", 0],
	["CGNY23", 0],
	["CGNY23A", 0],
	["CGNY23B", 0],
	["CGNY23BN", 0],
	["CGNY23N", 0],
	["CGNY24B", 0],
	["CGNY25", 0],
	["CGNY26", 0],
	["CGNY27", 0],
	["CGNY27A", 0],
	["CGNY27B", 0],
	["CGNY30", 0],
	["CGNY31", 0],
	["CGNY33", 0],
	["CGNY34", 0],
	["CGNY35", 0],
	["CGSR10", 0],
	["CGSR10A", 0],
	["CGSR10N", 0],
	["CGSR10S", 0],
	["CGSR11", 0],
	["CGSR11A", 0],
	["CGSR11N", 0],
	["CGSR11S", 0],
	["CGSR12", 0],
	["CGSR13", 0],
	["CGSR13N", 0],
	["CGSR13SN", 0],
	["CGSR14", 0],
	["CGSR14A", 0],
	["CGSR15", 0],
	["CGSR15A", 0],
	["CGSR16", 0],
	["CGSR16A", 0],
	["CGSR16S", 0],
	["CGSR17", 0],
	["CGSR17A", 0],
	["CGSR17N", 0],
	["CGSR17SN", 0],
	["CGSR20", 0],
	["CGSR20A", 0],
	["CGSR20N", 0],
	["CGSR20S", 0],
	["CGSR20SN", 0],
	["CGSR21", 0],
	["CGSR21A", 0],
	["CGSR21N", 0],
	["CGSR21S", 0],
	["CGSR21SN", 0],
	["CGSR22", 0],
	["CGSR22A", 0],
	["CGSR22N", 0],
	["CGSR22S", 0],
	["CGSR23", 0],
	["CGSR23A", 0],
	["CGSR23N", 0],
	["CGSR23SN", 0],
	["CGSR24", 0],
	["CGSR24A", 0],
	["CGSR24N", 0],
	["CGSR24S", 0],
	["CGSR25", 0],
	["CGSR25A", 0],
	["CGSR25S", 0],
	["CGSR26", 0],
	["CGSR26A", 0],
	["CGSR26N", 0],
	["CGSR26S", 0],
	["CGSR27", 0],
	["CGSR27A", 0],
	["CGSR28", 0],
	["CGSR28SN", 0],
	["CGSR29", 0],
	["CGSR29A", 0],
	["CGSR29N", 0],
	["CGSR29S", 0],
	["CGSR30", 0],
	["CGSR31", 0],
	["CGSR31A", 0],
	["CGSR33N", 0],
	["CGSR34", 0],
	["CGSR40A", 0],
	["CGSR41A", 0],
	["CGSR42A", 0],
	["CGSY10", 0],
	["CGSY10B", 0],
	["CGSY11", 0],
	["CGSY11B", 0],
	["CGSY12", 0],
	["CGSY12B", 0],
	["CGSY13", 0],
	["CGSY14", 0],
	["CGSY15", 0],
	["CGSY16", 0],
	["CGSY17", 0],
	["CGSY18", 0],
	["CGSY19", 0],
]

for i in range(len(list)):
	nameA = list[i][0] + ".bmp"
	nameB = list[i][0] + "_M.bmp"
	col = list[i][1]
	
	print "clip ... " + nameA + " " + nameB
	p = Image.open(nameB)
	iw, ih = p.size
	
	sx = GetLR(p, iw, ih, col)
	ex = GetRL(p, iw, ih, col)
	sy = GetUD(p, iw, ih, col)
	
	if(sx % 2):
		sx -= 1
	
	if(ex % 2):
		ex += 1
	
	if(sy % 2):
		sy -= 1
	
	ax = (iw / 2) - sx
	bx = ex - (iw / 2)
	
	if(ax > bx):
		s = (iw / 2) - ax
		e = (iw / 2) + ax
	else:
		s = (iw / 2) - bx - 1
		e = (iw / 2) + bx + 1
	
	p2 = p.crop((s, sy, e, ih))
	p2.save(nameB)
	
	p3 = Image.open(nameA)
	p4 = p3.crop((s, sy, e, ih))
	p4.save(nameA)

# ---------------------------------------------------------------------------
nameA = "TITLE_LG.bmp"
nameB = "TITLE_LG_M.bmp"

p = Image.open(nameB)

print "clip ... " + nameA + " " + nameB
p2 = p.crop((24, 0, 216, 72))
p2.save(nameB)

p3 = Image.open(nameA)
p4 = p3.crop((24, 0, 216, 72))
p4.save(nameA)


# ---------------------------------------------------------------------------
for i in range(len(a)):
	Img2bin(a[i])

for i in range(len(am)):
	Img2mask(am[i])


