#ifndef __FILE_H__
#define __FILE_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define FILE_MAX_SCENE_CNT		134


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
EWRAM_CODE void  FileInit(void);

EWRAM_CODE u8*   FileGetDat(u32 no);
EWRAM_CODE u8*   FileGetImg(char* pStr);
EWRAM_CODE u8*   FileGetImgMask(char* pStr);
EWRAM_CODE u8*   FileGetSnd(u32 no);
EWRAM_CODE u8*   FileGetSe(char* pStr);
EWRAM_CODE u32   FileGetSize(void);
EWRAM_CODE char* FileGetScene(u32 num);

EWRAM_CODE void  FileCalcToupper(char* pStr);


#ifdef __cplusplus
}
#endif
#endif
