#include "se.h"
#include "libmy/snd.h"
#include "file.h"


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
EWRAM_CODE void SeInit(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void SePlay(char* pStr, bool isLoop)
{
	u8* pDat = FileGetSe(pStr);
	u32 size = FileGetSize();

	SndSetData(pDat, size, -6, isLoop);
	SndPlay();
}
//---------------------------------------------------------------------------
EWRAM_CODE void SeStop(void)
{
	SndStop();
}
//---------------------------------------------------------------------------
EWRAM_CODE bool SeIsEnd(void)
{
	return SndIsEnd();
}
